/* computorv1.c */

#include "computorv1.h"

/**
 * GLOBALS
 */

char *input_g_err;
s_token *tokens_g_err;
s_term *terms_g_err;
s_polynom *polynom_g_err;

/**
 * PROGRAM
 */

static void remove_spaces(char *s)
{
    char *read = s;
    char *write = s;

    // copy all non-space chars
    while (*read)
    {
        if (!ft_isspace(*read))
        {
            *write++ = *read;
        }
        read++;
    }
    *write = '\0';

    // zero the rest of the buffer
    while (write != read)
    {
        *write++ = '\0';
    }
}

static size_t count_any_of(const char *s, const char *set)
{
    size_t count = 0;
    for (; *s != '\0'; s++)
    {
        if (ft_strchr(set, *s) != NULL)
        {
            count++;
        }
    }
    return count;
}

static void tokens_fill_null(s_token *tokens, size_t arg_len)
{
    size_t i;

    i = 0;
    while (i < arg_len)
    {
        tokens[i].type = TOKEN_END;
        tokens[i].tag = TOKEN_NO_TAG;
        tokens[i].value_char = '\0';
        i++;
    }
}

static void terms_fill_null(s_term *terms, size_t terms_count_prediction)
{
    size_t i;

    i = 0;
    while (i < terms_count_prediction)
    {
        terms[i].coefficient = 0.0;
        terms[i].exponent = 0;
        terms[i].position = TERM_END;
        terms[i].sign = TERM_NULL;
        i++;
    }
}

int main(int ac, char **av)
{
    int ret;
    size_t arg_len;
    size_t terms_count_prediction;
    char *input;

    if (ac < 2)
    {
        return 0;
    }

    // init
    input = av[1];
    input_g_err = input;
    remove_spaces(input);

    // lexerize
    arg_len = ft_strlen(input) + 1;        // +1 for last END token
    ft_printf("-> tokens[%i]\n", arg_len); // debug
    s_token tokens[arg_len];
    tokens_g_err = tokens;
    tokens_fill_null(tokens, arg_len);
    ret = lexerize(input, tokens);
    if (ret == 0)
    {
        stop_errors(ERROR_TOKEN_COUNT, "lexer returned 0 token");
    }

    // parse
    terms_count_prediction = count_any_of(input, "-+=") + 2; // +1 for first term that can have no leading '+', +1 for last term == NULL
    ft_printf("-> terms[%i]\n", terms_count_prediction);     // debug
    s_term terms[terms_count_prediction];
    terms_g_err = terms;
    terms_fill_null(terms, terms_count_prediction);
    ret = parse(tokens, terms, terms_count_prediction);
    if (ret == 0)
    {
        stop_errors(ERROR_TERM_COUNT, "parser returned 0 term");
    }

    // reduce
    s_polynom polynom[1];
    polynom_g_err = polynom;
    reduce(terms, polynom);

    // debug
    print_state();

    return (0);
}
